#include <stdio.h>
#include <math.h>
#include <time.h>
// 点
// point
struct point{ double x;double y;};
struct point points[10001];
struct point result_points[1000001];
// 多角形
struct polygon_type{
	struct point points[10001];
	int point_number;
	double max_distance;
};
struct polygon_type polygon;
struct point minpoint;
struct circle{
	double r;
	double x,y;
};
struct circle circles[10001];
//　二乗を計算
// calculating the square
double pow2(double val){
	return val * val;
}
// 多角形を生成する関数
// making polygons
void MakePolygon(){
	int i;
	double dist;
	polygon.max_distance = 0;
	polygon.points[0].x= 10000*cos((double)0 /10000 * M_PI * 2); 
	polygon.points[0].y = 10000*sin((double)0 /10000 * M_PI * 2); 
	for(i = 1;i<=10000;i++){
		polygon.points[i].x = 10000*cos((double)i /10000 * M_PI * 2); 
		polygon.points[i].y = 10000*sin((double)i /10000 * M_PI *2); 
		dist = sqrt(pow2(polygon.points[i].x-polygon.points[i-1].x)+pow2(polygon.points[i].y-polygon.points[i-1].y));
		polygon.max_distance = polygon.max_distance > dist ? polygon.max_distance : dist;
	}
	polygon.point_number=10000;
}
void MakeCircles(){
	int i;
	for(i = 0; i< 10001;i++){
		circles[i].r = rand()%10000;	
		circles[i].x = rand()%10000 - 5000;	
		circles[i].y = rand()%10000 -5000;	
	}
}
// カンガルー法を使った多角形と円の交点算出
// calculating the intersection between polygon and circle
void KangarooMethod(){
	int i,j,k=0;
	double a,b,c,d;
	double ksi,eta,delta,ramda,mu;
	int jump;
	struct point CrossP;
	FILE *fp;
	fp = fopen("tmp3","w");
	for(i = 0 ;i<=10000;i++){
		for(j =0;j<polygon.point_number-1;){
			// 交わっている時
			// when the polygon and the circle intersects
			if(
				(sqrt(
					pow2(circles[i].x - polygon.points[j].x) + 
		  	   		pow2(circles[i].y - polygon.points[j].y)
				) -circles[i].r)  *
				(sqrt(
					pow2(circles[i].x - polygon.points[j+1].x) + 
		  	   		pow2(circles[i].y - polygon.points[j+1].y)
				) -circles[i].r )
				<0
			){
				a = polygon.points[j+1].y - polygon.points[j].y;
				b = polygon.points[j].x - polygon.points[j+1].x;
				c = (polygon.points[j].y - polygon.points[j+1].y)*polygon.points[j].x  + (polygon.points[j+1].x - polygon.points[j].x)*polygon.points[j].y;;
				d = a * circles[i].x + b * circles[i].y  + c;
				CrossP.x = circles[i].x + (-a * d + b * sqrt((a*a + b*b)*circles[i].r*circles[i].r - d *d)) / (a * a + b* b);	
				CrossP.y = circles[i].y + (-b * d - a * sqrt((a*a + b*b)*circles[i].r*circles[i].r - d *d)) / (a * a + b* b);	
				if((CrossP.x < polygon.points[j].x && CrossP.x > polygon.points[j+1].x)|| (CrossP.x > polygon.points[j].x && CrossP.x < polygon.points[j+1].x)){
					fprintf(fp,"circle %f %f %f\n",circles[i].r,circles[i].x,circles[i].y);
					fprintf(fp,"segment %f %f %f %f\n",polygon.points[j].x,polygon.points[j].y,polygon.points[j+1].x,polygon.points[j+1].y);
					fprintf(fp,"Cross points %f %f\n",CrossP.x,CrossP.y);
				}
				CrossP.x = circles[i].x + (-a * d - b * sqrt((a*a + b*b)*circles[i].r*circles[i].r - d *d)) / (a * a + b* b);	
				CrossP.y = circles[i].y + (-b * d + a * sqrt((a*a + b*b)*circles[i].r*circles[i].r - d *d)) / (a * a + b* b);	
				if((CrossP.x < polygon.points[j].x && CrossP.x > polygon.points[j+1].x) || (CrossP.x > polygon.points[j].x && CrossP.x < polygon.points[j+1].x)){
					fprintf(fp,"circle %f %f %f\n",circles[i].r,circles[i].x,circles[i].y);
					fprintf(fp,"segment %f %f %f %f\n",polygon.points[j].x,polygon.points[j].y,polygon.points[j+1].x,polygon.points[j+1].y);
					fprintf(fp,"Cross points %f %f\n",CrossP.x,CrossP.y);
				}
			}
			jump = fabs(sqrt(pow2((polygon.points[j+1].y - circles[i].y))+ pow2((polygon.points[j+1].x - circles[i].x))) - circles[i].r)/polygon.max_distance + 1;
			j+=jump;
		} 
	}	
}
void SimpleMethod(){
	int i,j,k=0;
	double a,b,c,d;
	double ksi,eta,delta,ramda,mu;
	struct point CrossP;
	FILE *fp;
	fp = fopen("tmp2","w");
	for(i = 0 ;i<=10000;i++){
		for(j =0;j<polygon.point_number-1;j++){
			if(
				(sqrt(
					pow2(circles[i].x - polygon.points[j].x) + 
		  	   		pow2(circles[i].y - polygon.points[j].y)
				) -circles[i].r)  *
				(sqrt(
					pow2(circles[i].x - polygon.points[j+1].x) + 
		  	   		pow2(circles[i].y - polygon.points[j+1].y)
				) -circles[i].r )
				<0
			){
				a = polygon.points[j+1].y - polygon.points[j].y;
				b = polygon.points[j].x - polygon.points[j+1].x;
				c = (polygon.points[j].y - polygon.points[j+1].y)*polygon.points[j].x  + (polygon.points[j+1].x - polygon.points[j].x)*polygon.points[j].y;;
				d = a * circles[i].x + b * circles[i].y  + c;
				CrossP.x = circles[i].x + (-a * d + b * sqrt((a*a + b*b)*circles[i].r*circles[i].r - d *d)) / (a * a + b* b);	
				CrossP.y = circles[i].y + (-b * d - a * sqrt((a*a + b*b)*circles[i].r*circles[i].r - d *d)) / (a * a + b* b);	
				if((CrossP.x < polygon.points[j].x && CrossP.x > polygon.points[j+1].x) || (CrossP.x > polygon.points[j].x && CrossP.x < polygon.points[j+1].x)){
					fprintf(fp,"circle %f %f %f\n",circles[i].r,circles[i].x,circles[i].y);
					fprintf(fp,"segment %f %f %f %f\n",polygon.points[j].x,polygon.points[j].y,polygon.points[j+1].x,polygon.points[j+1].y);
					fprintf(fp,"Cross points %f %f\n",CrossP.x,CrossP.y);
				}
				CrossP.x = circles[i].x + (-a * d - b * sqrt((a*a + b*b)*circles[i].r*circles[i].r - d *d)) / (a * a + b* b);	
				CrossP.y = circles[i].y + (-b * d + a * sqrt((a*a + b*b)*circles[i].r*circles[i].r - d *d)) / (a * a + b* b);	
				if((CrossP.x < polygon.points[j].x && CrossP.x > polygon.points[j+1].x) || (CrossP.x > polygon.points[j].x && CrossP.x < polygon.points[j+1].x)){
					fprintf(fp,"circle %f %f %f\n",circles[i].r,circles[i].x,circles[i].y);
					fprintf(fp,"segment %f %f %f %f\n",polygon.points[j].x,polygon.points[j].y,polygon.points[j+1].x,polygon.points[j+1].y);
					fprintf(fp,"Cross points %f %f\n",CrossP.x,CrossP.y);
				}
			}
		} 
	}	
}
int main(){
	int t1,t2;
	
	MakePolygon();
	MakeCircles();
	// 時間を計測
	t1 = clock();
	SimpleMethod();
	t2 = clock();
	printf("time1 = %f[s]\n", (double)(t2-t1)/CLOCKS_PER_SEC);
	t1 = clock();
	KangarooMethod();
	t2 = clock();
	printf("time2 = %f[s]\n", (double)(t2-t1)/CLOCKS_PER_SEC);
}


